HDU 1501

Zipper

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 7813    Accepted Submission(s): 2765

Problem Description

Given three strings, you are to determine whether the third string can be formed by combining the characters in the first two strings. The first two strings can be mixed arbitrarily, but each must stay in its original order.

For example, consider forming "tcraete" from "cat" and "tree":

String A: cat

String B: tree

String C: tcraete

As you can see, we can form the third string by alternating characters from the two strings. As a second example, consider forming "catrtee" from "cat" and "tree":

String A: cat

String B: tree

String C: catrtee

Finally, notice that it is impossible to form "cttaree" from "cat" and "tree".

Input

The first line of input contains a single positive integer from 1 through 1000. It represents the number of data sets to follow. The processing for each data set is identical. The data sets appear on the following lines, one data set per line.

For each data set, the line of input consists of three strings, separated by a single space. All strings are composed of upper and lower case letters only. The length of the third string is always the sum of the lengths of the first two strings. The first two
strings will have lengths between 1 and 200 characters, inclusive.

Output

For each data set, print:

Data set n: yes

if the third string can be formed from the first two, or

Data set n: no

if it cannot. Of course n should be replaced by the data set number. See the sample output below for an example.

Sample Input

3

cat tree tcraete

cat tree catrtee

cat tree cttaree

Sample Output

Data set 1: yes

Data set 2: yes

Data set 3: no

//本题主要思路根据第三个字符串dnf搜索从前两个字符串中查找,查找到的字符放入数组res中,当res与第三个字符串相等时搜索结

//束

#include <stdio.h>
#include <string.h>
char ss[420];
char s1[210];
char s2[210];
char res[420];
bool vis[210][210];   //用数组记录很重要不然会超时
int flag,cnt,len1,len2;
void dfs(int ini,int init)
{
    if(vis[ini][init]) return;
    vis[ini][init]=1;
    if(strcmp(res,ss)==0)
    {
        flag=1;
        return;
    }
    else
    {
            if(s1[ini]==ss[cnt])  //当搜索到与第三字符串中的字符相等时记录下字符再递归搜索
            {
                res[cnt++]=s1[ini];
                dfs(ini+1,init);
                cnt--;
                if(flag)
                    return;
            }
         if(s2[init]==ss[cnt])
            {
                res[cnt++]=s2[init];
                dfs(ini,init+1);
                cnt--;
                if(flag)
                    return;

            }
    }
}

int main()
{
    int n;
    int cnt1=1;
    scanf("%d",&n);
    getchar();
    while(n--)
    {
        scanf("%s%s%s",s1,s2,ss);
        len1=strlen(s1);
        len2=strlen(s2);
        cnt=flag=0;
        memset(res,'\0',sizeof(res));  //我调试了快半个小时了,才发现如果用0的话数组不能完全清空
        memset(res,0,sizeof(vis));
        dfs(0,0);
        printf("Data set %d:",cnt1++);
        if(flag)
            printf(" yes\n"); //注意空格
        else
            printf(" no\n");
    }
    return 0 ;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-08-26 05:25:16

HDU 1501的相关文章

hdu 1501 Zipper dfs

题目链接: HDU - 1501 Given three strings, you are to determine whether the third string can be formed by combining the characters in the first two strings. The first two strings can be mixed arbitrarily, but each must stay in its original order.For examp

hdu 1501 Zipper (dfs+记忆化搜索)

Zipper Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6491    Accepted Submission(s): 2341 Problem Description Given three strings, you are to determine whether the third string can be formed

HDU 1501 Zipper

Problem Description Given three strings, you are to determine whether the third string can be formed by combining the characters in the first two strings. The first two strings can be mixed arbitrarily, but each must stay in its original order. For e

HDU 1501 Zipper(DP,DFS)

题意  判断能否由字符串a,b中的字符不改变各自的相对顺序组合得到字符串c 本题有两种解法  DP或者DFS 考虑DP  令d[i][j]表示能否有a的前i个字符和b的前j个字符组合得到c的前i+j个字符  值为0或者1  那么有d[i][j]=(d[i-1][j]&&a[i]==c[i+j])||(d[i][j-1]&&b[i]==c[i+j])   a,b的下标都是从1开始的  注意0的初始化 #include<cstdio> #include<cst

hdu 1501 Zipper 记忆化搜索

Zipper Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 7188    Accepted Submission(s): 2571 Problem Description Given three strings, you are to determine whether the third string can be formed

hdu 1501 Zipper(DP)

题意: 给三个字符串str1.str2.str3 问str1和str2能否拼接成str3.(拼接的意思可以互相穿插) 能输出YES否则输出NO. 思路: 如果str3是由str1和str2拼接而成,str1的前i个字符和str2的前j个字符一定构成str3的前i+j个字符.(因为拼接必须保证字符的顺序不变) 所以,,,这算是个变形的最长公共子序列? DP方程:dp[i][j]:str3的前i+j个字符能否由str1的前i个字符和str2的前j个字符拼接而成.布尔型. 看代码,, 代码: char

POJ 2192 &amp;&amp; HDU 1501 Zipper (记忆化搜索)

Zipper Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 16803   Accepted: 5994 Description Given three strings, you are to determine whether the third string can be formed by combining the characters in the first two strings. The first tw

HDU 1501:(DFS)

不知道为什么一直超时,最后加了个剪枝就过了:合成单词的最后一个字母,应该至少和之前两个单词中的一个的最后一个字母相同 #include"cstdio" #include"cmath" #include"cstring" #include"iostream" #define MAXN 205 using namespace std; char arr[4][MAXN]; int len[4]; int vis[MAXN][MAX

HDU分类

模拟题, 枚举 1002 1004 1013 1015 1017 1020 1022 1029 1031 1033 1034 1035 1036 1037 1039 1042 1047 1048 1049 1050 1057 1062 1063 1064 1070 1073 1075 1082 1083 1084 1088 1106 1107 1113 1117 1119 1128 1129 1144 1148 1157 1161 1170 1172 1177 1197 1200 1201 12